package benefactorkindboxhandler

import (
	"net/http"

	param "git.gocasts.ir/ebhomengo/niki/param/benefactor/kind_box"
	httpmsg "git.gocasts.ir/ebhomengo/niki/pkg/http_msg"
	echo "github.com/labstack/echo/v4"
)

// GetAll godoc
// @Summary      Get all kind boxes for a benefactor
// @Tags         KindBox
// @Accept       json
// @Produce      json
// @Success      200  {object}  param.KindBoxGetResponse
// @Failure      400  {string}  "Bad request"
// @Security	 AuthBearerBenefactor
// @Router       /benefactor/kindboxes [get]
func (h Handler) GetAll(c echo.Context) error {
	var req param.KindBoxGetAllRequest
	if bErr := c.Bind(&req); bErr != nil {
		return echo.NewHTTPError(http.StatusBadRequest)
	}

	resp, sErr := h.benefactorKindBoxSvc.GetAll(c.Request().Context(), req)
	if sErr != nil {
		msg, code := httpmsg.Error(sErr)

		return echo.NewHTTPError(code, msg)
	}

	return c.JSON(http.StatusOK, resp)
}
